<template>
  <PageWrapper dense>
    <Row>
      <!-- 左边部门选择 -->
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 4 }" class="h-[calc(100vh-80px)]">
        <DeptTree
          v-model:selectDeptId="selectDeptId"
          v-model:searchValue="searchValue"
          @select="reload"
        />
      </Col>
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 20 }">
        <BasicTable @register="registerTable">
          <template #toolbar>
            <a-button
              type="primary"
              @click="
                downloadExcel(
                  infoMaintenanceExport,
                  '维保单位信息数据',
                  getForm().getFieldsValue()
                )
              "
              v-auth="'elevator:info:export'"
              >导出</a-button
            >
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'action'"> </template>
          </template>
        </BasicTable>
      </Col>
    </Row>
    <InfoModal @register="registerModal" @reload="reload" />
    <UserImportModal @register="registerImportModal" @reload="reload" />
  </PageWrapper>
</template>

<script setup lang="ts">
import { Row, Col, Space, Avatar } from "ant-design-vue";
import { PageWrapper } from "@/components/Page";
import { BasicTable, useTable, TableAction } from "@/components/Table";
import {
  infoList,
  infoExport,
  infoRemove,
  evaMaintanceList,
  evaMaintancesList,
  infoMaintenanceExport,
} from "@/api/basicInfo/elevator";
import { downloadExcel } from "@/utils/file/download";
import { useModal } from "@/components/Modal";
import InfoModal from "./InfoModal.vue";
import { formSchemas, columns } from "./info.data";
import { IconEnum } from "@/enums/appEnum";
import { ref, toValue } from "vue";
import DeptTree from "./DeptTree.vue";
import UserImportModal from "./UserImportModal.vue";

defineOptions({ name: "Info" });
// 左边部门用
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>("");
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: "checkbox",
  },
  title: "维保状态统计列表",
  api: evaMaintancesList,
  showIndexColumn: false,
  rowKey: "id",
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = "";
      // await reload();
    },
  },
  columns: columns,
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
});

const [registerModal, { openModal }] = useModal();
const [registerImportModal, { openModal: openImportModal }] = useModal();
function handleEdit(record: Recordable) {
  openModal(true, { record, update: true });
}

function handleAdd() {
  openModal(true, { update: false });
}
function handleImport() {
  openImportModal(true);
}
async function handleDelete(record: Recordable) {
  await infoRemove([record.id]);
  await reload();
}
</script>

<style scoped></style>
